package message

type Command string

// client commands
const (
	CAP          Command = "CAP"
	AUTHENTICATE Command = "AUTHENTICATE"
	PASS         Command = "PASS"
	NICK         Command = "NICK"
	USER         Command = "USER"
	OPER         Command = "OPER"
	QUIT         Command = "QUIT"

	JOIN   Command = "JOIN"
	PART   Command = "PART"
	TOPIC  Command = "TOPIC"
	NAMES  Command = "NAMES"
	LIST   Command = "LIST"
	INVITE Command = "INVITE"
	KICK   Command = "KICK"

	MOTD    Command = "MOTD"
	VERSION Command = "VERSION"
	ADMIN   Command = "ADMIN"
	CONNECT Command = "CONNECT"
	TIME    Command = "TIME"
	STATS   Command = "STATS"
	INFO    Command = "INFO"
	MODE    Command = "MODE"

	PRIVMSG Command = "PRIVMSG"
	NOTICE  Command = "NOTICE"

	KILL Command = "KILL"

	AWAY     Command = "AWAY"
	USERHOST Command = "USERHOST"
)

// numerics
const (
	RPL_WELCOME  Command = "001"
	RPL_YOURHOST Command = "002"
	RPL_CREATED  Command = "003"
	RPL_MYINFO   Command = "004"
	RPL_ISUPPORT Command = "005"

	RPL_BOUNCE Command = "010"

	RPL_UMODEIS       Command = "221"
	RPL_LUSERCLIENT   Command = "251"
	RPL_LUSEROP       Command = "252"
	RPL_LUSERUNKNOWN  Command = "253"
	RPL_LUSERCHANNELS Command = "254"
	RPL_LUSERME       Command = "255"
	RPL_ADMINME       Command = "256"
	RPL_ADMINLOC1     Command = "257"
	RPL_ADMINLOC2     Command = "258"
	RPL_ADMINEMAIL    Command = "259"

	RPL_TRYAGAIN Command = "263"

	RPL_LOCALUSERS  Command = "265"
	RPL_GLOBALUSERS Command = "266"

	RPL_WHOISCERTFP Command = "276"

	RPL_NONE Command = "300"

	RPL_AWAY     Command = "301"
	RPL_USERHOST Command = "302"
	RPL_ISON     Command = "303"
	RPL_UNAWAY   Command = "305"
	RPL_NOWAWAY  Command = "306"

	RPL_WHOISUSER     Command = "311"
	RPL_WHOISSERVER   Command = "312"
	RPL_WHOISOPERATOR Command = "313"
	RPL_WHOWASUSER    Command = "314"
	RPL_WHOISIDLE     Command = "317"
	RPL_ENDOFWHOIS    Command = "318"
	RPL_WHOISCHANNELS Command = "319"

	RPL_LISTSTART Command = "321"
	RPL_LIST      Command = "322"
	RPL_LISTEND   Command = "323"

	RPL_CHANNELMODEIS Command = "324"
	RPL_CREATIONTIME  Command = "329"
	RPL_NOTOPIC       Command = "331"
	RPL_TOPIC         Command = "332"
	RPL_TOPICWHOTIME  Command = "333"

	RPL_INVITING        Command = "341"
	RPL_INVITELIST      Command = "346"
	RPL_ENDOFINVITELIST Command = "347"
	RPL_EXCEPTLIST      Command = "348"
	RPL_ENDOFEXCEPTLIST Command = "349"

	RPL_VERSION Command = "351"

	RPL_NAMREPLY     Command = "353"
	RPL_ENDOFNAMES   Command = "366"
	RPL_BANLIST      Command = "367"
	RPL_ENDOFBANLIST Command = "368"
	RPL_ENDOFWHOWAS  Command = "369"

	RPL_MOTD      Command = "372"
	RPL_MOTDSTART Command = "375"
	RPL_ENDOFMOTD Command = "376" // see also ERR_NOMOTD

	RPL_YOUREOPER Command = "381"

	RPL_REHASHING Command = "382"

	ERR_UNKNOWNERROR     Command = "400"
	ERR_NOSUCHNICK       Command = "401"
	ERR_NOSUCHSERVER     Command = "402"
	ERR_NOSUCHCHANNEL    Command = "403"
	ERR_CANNOTSENDTOCHAN Command = "404"
	ERR_TOOMANYCHANNELS  Command = "405"

	ERR_UNKNOWNCOMMAND Command = "421"

	ERR_NOMOTD Command = "422"

	ERR_ERRONEUSNICKNAME Command = "432"
	ERR_NICKNAMEINUSE    Command = "433"

	ERR_USERNOTINCHANNEL Command = "441"
	ERR_NOTONCHANNEL     Command = "442"
	ERR_USERONCHANNEL    Command = "443"

	ERR_NOTREGISTERED Command = "451"

	ERR_NEEDMOREPARAMS    Command = "461"
	ERR_ALREADYREGISTERED Command = "462"
	ERR_PASSWDMISMATCH    Command = "464"
	ERR_YOUREBANNEDCREEP  Command = "465"
	ERR_CHANNELISFULL     Command = "471"
	ERR_UNKNOWNMODE       Command = "472"
	ERR_INVITEONLYCHAN    Command = "473"
	ERR_BANNEDFROMCHAN    Command = "474"
	ERR_BADCHANNELKEY     Command = "475"
	ERR_BADCHANMASK       Command = "476"

	ERR_NOPRIVILEGES     Command = "481"
	ERR_CHANOPRIVSNEEDED Command = "482"
	ERR_CANTKILLSERVER   Command = "483"
	ERR_NOOPERHOST       Command = "491"

	ERR_UMODEUNKNOWNFLAG Command = "501"
	ERR_USERSDONTMATCH   Command = "502"

	RPL_STARTTLS Command = "670"
	ERR_STARTTLS Command = "691"

	ERR_NOPRIVS Command = "723"

	RPL_LOGGEDIN    Command = "900"
	RPL_LOGGEDOUT   Command = "901"
	ERR_NICKLOCKED  Command = "902"
	RPL_SASLSUCCESS Command = "903"
	ERR_SASLFAIL    Command = "904"
	ERR_SASLTOOLONG Command = "905"
	ERR_SASLABORTED Command = "906"
	ERR_SASLALREADY Command = "907"
	RPL_SASLMECHS   Command = "908"
)
